' ALLOY - Bullet alloy calculator
'
'         Linotype using 50/50 lead-antimony,
'                        50/50 bar solder
'                        Pure lead
'
'         Lyman #2 using 50/50 lead-antimony
'                        50/50 bar solder
'                        Pure lead
'
'         Lyman #2 using Linotype
'                        50/50 bar solder
'                        Pure lead
'
' Note: I find wheelweights an undependable source of
'       antimony as there is too much variation
'       in composition.  Their composition varies with
'       date of manufactured and source.  I therefore
'       consider them a pain in the nether regions.
'
on error goto errtrap
dim alt$(3)
dim als$(3)
alt$(0) = "Copyright 1987, Thomas E. Enright"
alt$(1) = "Linotype from 50/50 antimony-lead"
alt$(2) = "Lyman #2 from 50/50 antimony-lead"
alt$(3) = "Lyman #2 from linotype"
alt$(0) = "Copyright 1987, Thomas E. Enright"
als$(1) = "Antimony-lead"
als$(2) = "Antimony-lead"
als$(3) = "     Linotype"
msg1$ = "Amount of alloy should be from 1 to 100 pounds."
wgtmsk$ = "###.##            ####"
pctmsk$ = "###.# %"
color 2,0
running% = 0
getdecision% = 0
getaction% = 0
calculating = 0
while running% = 0
   choiceok% = 0
   formula% = 0
   cls
   print
   print
   print "Bullet Alloy Calculator ver 2.0"
   print "Copyright 1987, Thomas Enright"
   print
   print
   print "Select one of the following:"
   print
   print "      1. Linotype from 50/50 antimony-lead alloy"
   print "      2. Lyman #2 alloy from 50/50 antimony-lead"
   print "      3. Lyman #2 alloy from linotype"
   print
   print "              Enter your choice : "
   print
   print
   print "All choices assume 50/50 bar solder as the source of tin"
   print "and pure lead as the source of lead.  Choices hinge on"
   print "the source of antimony for your alloy."
   do
     choice$ = fngetstring$(13,35,"")
     choice$ = ucase$(left$(choice$,1))
     select case choice$
        case "1","2","3"
          formula% = val(choice$)
          atype$ = alt$(formula%)
          asource$ = als$(formula%)
          choiceok% = 1
        case else
          locate 13,35
          call clreol
     end select
   loop until choiceok% = 1
   cls
   goahead% = 0
   p1% = 0
   p2% = 0
   p3% = 0
   print
   print atype$
   print
   print
   print "Enter amount of alloy : "
   print
   print "                  Pounds            Ounces"
   print "                  ------            ------"
   print asource$
   print " 50/50 solder"
   print "         Lead"
   print
   print
   print "Composition by percent :"
   print
   print "         Lead"
   print "     Antimony"
   print "          Tin"
   alloy = fngetreal(5,25,1,100,1,msg1$)
   while goahead% = 0
      getdecision% = 0
      calculating% = 0
      while calculating% = 0
         on formula% gosub linal, l2al, l2lin
         p1% = fnfracpart%(basealloy) 'Is fractional part within range?
         p2% = fnfracpart%(asolder)
         p3% = fnfracpart%(alead)
         if (p1% = 1) and (p2% = 1) and (p3% = 1) then calculating% = 1
         if calculating% = 0 then
            alloy = alloy + 0.02
            locate 5,25
            print using "#####.##";alloy
         end if ' calculating = 0
      wend ' calculating
      locate 5,25
      print using wgtmsk$;alloy
      locate 9,19
      print using wgtmsk$;basealloy;basealloy * 16
      locate 10,19
      print using wgtmsk$;asolder,asolder * 16
      locate 11,19
      print using wgtmsk$;alead;alead * 16
      locate 16,19
      print using pctmsk$;clead
      locate 17,19
      print using pctmsk$;cant
      locate 18,19
      print using pctmsk$;ctin
      print
      print
      while getdecision% = 0
        getaction% = 0
        row% = csrlin
        locate row%,1
        print "    P)rint hardcopy, C)ontinue, S)tart over or Q)uit : ";
        col% = pos
        do
           locate row%,col%
           call clreol
           y$ = fngetstring$(row%,col%,"C")
           y$ = ucase$(left$(y$,1))
           if (y$ = "P") or (y$ = "C") or_
              (y$ = "S") or (y$ = "Q") then getaction% = 1
        loop until getaction% = 1
        select case y$
           case "P"
              presume:
              locate row%,1
              call clreol
              call interrupt 5
              lprint chr$(12)
           case "C"
              alloy = alloy + 0.02
              goahead% = 0
              getdecision% = 1
           case "S"
              goahead% = 1
              getdecision% = 1
           case "Q"
              goahead% = 1
              getdecision% = 1
              running% = 1
        end select
      wend ' getdecision
   wend ' goahead = 0
wend
end

linal: ' Linotype from 50/50 antimony-lead
  basealloy = 2 * (alloy * 0.12)
  asolder = 2 * (alloy * 0.04)
  alead = (alloy * 0.84) - ((basealloy / 2) + (asolder / 2))
  clead = ((alead + (asolder / 2) + (basealloy / 2)) / alloy) * 100
  ctin = ((asolder / 2) / alloy) * 100
  cant = ((basealloy /2) / alloy) * 100
return

l2al: ' Lyman #2 from 50/50 antimony-lead
  basealloy = 2 * (alloy * 0.05)
  asolder = 2 * (alloy * 0.05)
  alead = (alloy * 0.9) - ((asolder / 2) + (basealloy / 2))
  clead = ((alead + (asolder / 2) + (basealloy / 2)) / alloy) * 100.0
  ctin = ((asolder / 2) / alloy) * 100
  cant = ((basealloy / 2) / alloy) * 100
return

l2lin: ' Lyman #2 from Linotype
    basealloy = (alloy * 0.05) / 0.12
    asolder = 2 * ((alloy * 0.05) - (basealloy * 0.06))
    alead = (alloy * 0.9) - ((asolder / 2) + (basealloy * 0.84))
    clead = ((alead + (asolder / 2) + (basealloy * 0.84)) / alloy) * 100.0
    ctin = (((asolder / 2) + (basealloy * 0.06)) / alloy) * 100
    cant = ((basealloy * 0.12) / alloy) * 100
return

def fnfracpart%(metal)
local metal%
   metal = metal * 16 'Convert to ounces
   metal = metal - fix(metal) ' Save fractional part
   if (metal > 0.85) or (metal < 0.15) then_
      metal% = 1_
   else_
      metal% = 0
   fnfracpart% = metal%
end def


DEF FNGETSTRING$(ROW%,COL%,OLD$)
LOCAL TEMP$, CHAR$, CHAR%
   LOCATE ROW%,COL%+1
   CHAR$ = ""
   CALL ENTRYCURSOR
   WHILE CHAR$ <> CHR$(13)
     DO
       CHAR$ = INKEY$
     LOOP UNTIL LEN(CHAR$) > 0
     CHAR% = ASC(CHAR$)
     SELECT CASE CHAR%
        CASE 13
          IF LEN(TEMP$) = 0 THEN TEMP$ = OLD$
        CASE  8 ' Backspace
          IF LEN(TEMP$) > 0 THEN
             ' TEMPLEN% = LEN(TEMP$)
             TEMP$ = LEFT$(TEMP$,LEN(TEMP$)-1)
             LOCATE ROW%,COL% + LEN(TEMP$) + 1
             ' PRINT " ";
             CALL ENTRYCURSOR
             PRINT " ";
             LOCATE ROW%,COL% + LEN(TEMP$) + 1
          END IF
        CASE 32 TO 126 ' Printable character
       	  TEMP$ = TEMP$ + CHAR$
       	  LOCATE ROW%, COL% + LEN(TEMP$)
       	  IF LEN(TEMP$) = 1 THEN CALL PRINTOVER
          PRINT CHAR$;
     	  CALL ENTRYCURSOR
     END SELECT
   WEND
   LOCATE ROW%, COL%
   CALL PRINTOVER
   PRINT USING "   \             \   ";TEMP$;
   FNGETSTRING$ = TEMP$
END DEF

DEF FNGETREAL(ROW%,COL%,MIN!,MAX!,OLD,TILTMSG$)
LOCAL TEMP, ALLOK%, TEMP$, CHAR$, CHAR%, DECPNT%
REALRESET:
   LOCATE ROW%,COL%+1
   DECPNT% = 0
   CHAR$ = ""
   CALL ENTRYCURSOR
   WHILE CHAR$ <> CHR$(13)
     DO
       CHAR$ = INKEY$
     LOOP UNTIL LEN(CHAR$) > 0
     CHAR% = ASC(CHAR$)
     SELECT CASE CHAR%
        CASE 13
          IF LEN(TEMP$) = 0 THEN TEMP$ = STR$(OLD)
        CASE  8 ' Backspace
          IF LEN(TEMP$) > 0 THEN
             IF RIGHT$(TEMP$,1) = "." THEN DECPNT% = 0
             TEMP$ = LEFT$(TEMP$,LEN(TEMP$)-1)
             LOCATE ROW%,COL% + LEN(TEMP$) + 1
             CALL ENTRYCURSOR
             CALL PRINTOVER
          END IF
        CASE 46
          IF DECPNT% = 0 THEN
       	     TEMP$ = TEMP$ + CHAR$
       	     LOCATE ROW%, COL% + LEN(TEMP$)
       	     IF LEN(TEMP$) = 1 THEN CALL PRINTOVER
             PRINT CHAR$;
     	     CALL ENTRYCURSOR
          END IF
        CASE 48 TO 57
       	  TEMP$ = TEMP$ + CHAR$
       	  LOCATE ROW%, COL% + LEN(TEMP$)
       	  IF LEN(TEMP$) = 1 THEN CALL PRINTOVER
          PRINT CHAR$;
     	  CALL ENTRYCURSOR
     END SELECT
   WEND
   TEMP = VAL(TEMP$)
   ALLOK% = 0
   DO
     IF (TEMP >= MIN!) AND (TEMP <= MAX!) THEN ALLOK% = 1
     IF ALLOK% = 0 THEN
        CALL ERRTIME(TILTMSG$)
        LOCATE ROW%,COL%
        PRINT USING "#####.#";OLD;
        TEMP$ = ""
        GOTO REALRESET
     END IF
   LOOP UNTIL ALLOK% = 1
   LOCATE ROW%,COL%
   CALL PRINTOVER
   PRINT USING "#####.#"; TEMP
   FNGETREAL = TEMP
END DEF

SUB ERRTIME(ERRSTR$)
LOCAL DUMMY$, PAD$
    PAD$ = STRING$((75 - LEN(ERRSTR$)) / 2,32)
    LOCATE 18,1
    PRINT PAD$;ERRSTR$
    INPUT "                        Press ENTER to continue :",DUMMY$
    LOCATE 18,1
    CALL CLREOL
    PRINT
    CALL CLREOL
END SUB

SUB PRINTOVER
LOCAL ROW%, COL%, PAD$
    ROW% = CSRLIN
    COL% = POS
    PRINT "               ";
    LOCATE ROW%, COL%
END SUB

SUB CLREOL
LOCAL ROW%, COL%, PAD$
    ROW% = CSRLIN
    COL% = POS
    PAD$ = STRING$(80 - col%,32)
    PRINT PAD$;
    LOCATE ROW%, COL%
END SUB

SUB ENTRYCURSOR
   COLOR 26,0
   PRINT "_";
   COLOR 2,0
END SUB

errtrap:
  select case err
    case 24,25,27,57
      row% = csrlin
      col% = pos
      locate row%,1
      input "Printer not ready, correct and press ENTER ",er$
      resume presume
    case else
      print
      print "Unknown problem--terminating program."
      end
  end select
resume
